import { Data } from "./data.model";
import { Level, LevelFilter } from "./level.model";
import { Server, ServerFilter } from "./server.model";
import { UserJoinedServer } from "./user_joined_server.model";
import { UserJoinedVoiceChannel } from "./user_joined_voice_channel.model";

export interface User extends Data {
  id?: number;
  discordId?: number;
  name?: string;
  xp?: number;
  minecraftId?: number;
  ontime?: number;
  level?: Level;
  server?: Server;
  leftServer?: boolean;

  joinedServerCount?: number;
  joinedServers?: UserJoinedServer[];

  joinedVoiceChannelCount?: number;
  joinedVoiceChannels?: UserJoinedVoiceChannel[];

  userJoinedGameServerCount?: number;
  userJoinedGameServers?: [];
}

export interface UserFilter {
  id?: number;
  discordId?: number;
  name?: string;
  xp?: number;
  minecraftId?: number;
  ontime?: number;
  level?: LevelFilter;
  server?: ServerFilter;
  leftServer?: boolean;
}
